Cantera 2.6.0

Public Member Functions | Public Attributes | Protected Attributes | Friends | List of all members
DenseMatrix Class Reference
Numerical Utilities within Cantera

A class for full (non-sparse) matrices with Fortran-compatible data storage, which adds matrix operations to class Array2D. More...

`#include <DenseMatrix.h>`

Inheritance diagram for DenseMatrix:
[legend]
Collaboration diagram for DenseMatrix:
[legend]

## Public Member Functions
| DenseMatrix ()
| Default Constructor. More...
| DenseMatrix (size_t n, size_t m, doublereal v=0.0)
| Constructor. More...
| DenseMatrix (const DenseMatrix &y)
DenseMatrix & | operator= (const DenseMatrix &y)
void | resize (size_t n, size_t m, doublereal v=0.0)
| Resize the matrix. More...
virtual doublereal *const * | colPts ()
const doublereal *const * | const_colPts () const
| Return a const vector of const pointers to the columns. More...
virtual void | mult (const double *b, double *prod) const
virtual void | mult (const DenseMatrix &b, DenseMatrix &prod) const
| Multiply A*B and write result to `prod`. More...
virtual void | leftMult (const double *const b, double *const prod) const
| Left-multiply the matrix by transpose(b), and write the result to prod. More...
vector_int & | ipiv ()
| Return a changeable value of the pivot vector. More...
const vector_int & | ipiv () const
| Return a changeable value of the pivot vector. More...
Public Member Functions inherited from Array2D
| Array2D ()
| Default constructor. More...
| Array2D (const size_t m, const size_t n, const double v=0.0)
| Constructor. More...
| Array2D (const size_t m, const size_t n, const double *values)
| Constructor. More...
| Array2D (const Array2D &y)
Array2D & | operator= (const Array2D &y)
void | resize (size_t n, size_t m, double v=0.0)
| Resize the array, and fill the new entries with 'v'. More...
void | appendColumn (const vector_fp &c)
| Append a column to the existing matrix using a std vector. More...
void | appendColumn (const double *const c)
| Append a column to the existing matrix. More...
void | setRow (size_t n, const double *const rw)
| Set the nth row to array rw. More...
void | getRow (size_t n, double *const rw)
| Get the nth row and return it in a vector. More...
void | setColumn (size_t m, double *const col)
| Set the values in column m to those in array col. More...
void | getColumn (size_t m, double *const col)
| Get the values in column m. More...
void | zero ()
| Set all of the entries to zero. More...
doublereal & | operator() (size_t i, size_t j)
| Allows setting elements using the syntax A(i,j) = x. More...
doublereal | operator() (size_t i, size_t j) const
| Allows retrieving elements using the syntax x = A(i,j). More...
doublereal & | value (size_t i, size_t j)
| Returns a changeable reference to position in the matrix. More...
doublereal | value (size_t i, size_t j) const
| Returns the value of a single matrix entry. More...
size_t | nRows () const
| Number of rows. More...
size_t | nColumns () const
| Number of columns. More...
iterator | begin ()
| Return an iterator pointing to the first element. More...
iterator | end ()
| Return an iterator pointing past the last element. More...
const_iterator | begin () const
| Return a const iterator pointing to the first element. More...
const_iterator | end () const
| Return a const iterator pointing to past the last element. More...
vector_fp & | data ()
| Return a reference to the data vector. More...
const vector_fp & | data () const
| Return a const reference to the data vector. More...
doublereal * | ptrColumn (size_t j)
| Return a pointer to the top of column j, columns are contiguous in memory. More...
const doublereal * | ptrColumn (size_t j) const
| Return a const pointer to the top of column j, columns are contiguous in memory. More...

## Public Attributes
int | m_useReturnErrorCode
| Error Handling Flag. More...
int | m_printLevel
| Print Level. More...

## Protected Attributes
vector_int | m_ipiv
| Vector of pivots. Length is equal to the max of m and n. More...
std::vector< doublereal * > | m_colPts
| Vector of column pointers. More...
Protected Attributes inherited from Array2D
vector_fp | m_data
| Data stored in a single array. More...
size_t | m_nrows
| Number of rows. More...
size_t | m_ncols
| Number of columns. More...

## Friends
int | solve (DenseMatrix &A, double *b, size_t nrhs, size_t ldb)
| Solve Ax = b. Array b is overwritten on exit with x. More...
int | solve (DenseMatrix &A, DenseMatrix &b)
| Solve Ax = b for multiple right-hand-side vectors. More...
int | invert (DenseMatrix &A, int nn)

## Additional Inherited Members
Public Types inherited from Array2D
typedef vector_fp::iterator | iterator
| Type definition for the iterator class that is can be used by Array2D types. More...
typedef vector_fp::const_iterator | const_iterator
| Type definition for the const_iterator class that is can be used by Array2D types. More...

## Detailed Description

A class for full (non-sparse) matrices with Fortran-compatible data storage, which adds matrix operations to class Array2D.

The dense matrix class adds matrix operations onto the Array2D class. These matrix operations are carried out by the appropriate BLAS and LAPACK routines

Error handling from BLAS and LAPACK are handled via the following formulation. Depending on a variable, a singular matrix or other terminal error condition from LAPACK is handled by either throwing an exception or by returning the error code condition to the calling routine.

The int variable, m_useReturnErrorCode, determines which method is used. The default value of zero means that an exception is thrown. A value of 1 means that a return code is used.

Reporting of these LAPACK error conditions is handled by the class variable m_printLevel. The default is for no reporting. If m_printLevel is nonzero, the error condition is reported to Cantera's log file.

Definition at line 50 of file DenseMatrix.h.

## Constructor & Destructor Documentation

## ◆ DenseMatrix() [1/3]

DenseMatrix | ( |  | ) |

Default Constructor.

Definition at line 20 of file DenseMatrix.cpp.

## ◆ DenseMatrix() [2/3]

DenseMatrix | ( | size_t | n,
|  | size_t | m,
|  | doublereal | v = `0.0`
| ) |  |

Constructor.

Create an `n` by `m` matrix, and initialize all elements to `v`.

Parameters

  n | New number of rows
  m | New number of columns
  v | Default fill value. defaults to zero.

Definition at line 26 of file DenseMatrix.cpp.

References DenseMatrix::m_colPts, Array2D::m_data, DenseMatrix::m_ipiv, and Array2D::m_nrows.

## ◆ DenseMatrix() [3/3]

DenseMatrix | ( | const DenseMatrix & | y | ) |

Definition at line 40 of file DenseMatrix.cpp.

## Member Function Documentation

## ◆ operator=()

DenseMatrix & operator= | ( | const DenseMatrix & | y | ) |

Definition at line 54 of file DenseMatrix.cpp.

## ◆ resize()

void resize | ( | size_t | n,
|  | size_t | m,
|  | doublereal | v = `0.0`
| ) |  |

Resize the matrix.

Resize the matrix to n rows by m cols.

Parameters

  n | New number of rows
  m | New number of columns
  v | Default fill value. defaults to zero.

Definition at line 70 of file DenseMatrix.cpp.

References DenseMatrix::m_colPts, Array2D::m_data, DenseMatrix::m_ipiv, Array2D::m_ncols, Array2D::m_nrows, and Array2D::resize().

Referenced by Cantera::BasisOptimize(), MultiPhase::init(), MultiTransport::init(), DustyGasTransport::initialize(), MultiPhaseEquil::MultiPhaseEquil(), solveSP::solveSP(), and VCS_SOLVE::vcs_basopt().

## ◆ colPts()

doublereal *const * colPts | ( |  | ) |
| virtual

Definition at line 82 of file DenseMatrix.cpp.

## ◆ const_colPts()

const doublereal *const * const_colPts | ( |  | ) | const

Return a const vector of const pointers to the columns.

Note, the Jacobian can not be altered by this routine, and therefore the member function is const.

Returns
  a vector of pointers to the top of the columns of the matrices.

Definition at line 87 of file DenseMatrix.cpp.

References DenseMatrix::m_colPts.

Referenced by DenseMatrix::mult().

## ◆ mult() [1/2]

void mult | ( | const double * | b,
|  | double * | prod
| ) |  | const
| virtual

Definition at line 92 of file DenseMatrix.cpp.

## ◆ mult() [2/2]

void mult | ( | const DenseMatrix & | b,
|  | DenseMatrix & | prod
| ) |  | const
| virtual

Multiply A*B and write result to `prod`.

Take this matrix to be of size NxM.

Parameters

  [in] | b | DenseMatrix B of size MxP
  [out] | prod | DenseMatrix prod size NxP

Definition at line 107 of file DenseMatrix.cpp.

References DenseMatrix::const_colPts(), Array2D::nColumns(), and Array2D::nRows().

## ◆ leftMult()

void leftMult | ( | const double *const | b,
|  | double *const | prod
| ) |  | const
| virtual

Left-multiply the matrix by transpose(b), and write the result to prod.

Parameters

  b | left multiply by this vector. The length must be equal to n the number of rows in the matrix.
  prod | Resulting vector. This is of length m, the number of columns in the matrix

Definition at line 127 of file DenseMatrix.cpp.

References Array2D::nColumns(), Array2D::nRows(), and Array2D::value().

## ◆ ipiv() [1/2]

vector_int & ipiv | ( |  | ) |

Return a changeable value of the pivot vector.

Returns
  a reference to the pivot vector as a vector_int

Definition at line 138 of file DenseMatrix.cpp.

References DenseMatrix::m_ipiv.

## ◆ ipiv() [2/2]

const vector_int & ipiv | ( |  | ) | const
| inline

Return a changeable value of the pivot vector.

Returns
  a reference to the pivot vector as a vector_int

Definition at line 119 of file DenseMatrix.h.

References DenseMatrix::m_ipiv.

## Friends And Related Function Documentation

## ◆ solve [1/2]

int solve | ( | DenseMatrix & | A,
|  | double * | b,
|  | size_t | nrhs,
|  | size_t | ldb
| ) |  |
| friend

Solve Ax = b. Array b is overwritten on exit with x.

The solve function uses the LAPACK routine dgetrf to invert the m xy n matrix.

The factorization has the form

    A = P * L * U

where P is a permutation matrix, L is lower triangular with unit diagonal elements (lower trapezoidal if m > n), and U is upper triangular (upper trapezoidal if m < n).

The system is then solved using the LAPACK routine dgetrs

Parameters

  A | Dense matrix to be factored
  b | RHS(s) to be solved.
  nrhs | Number of right hand sides to solve
  ldb | Leading dimension of b, if nrhs > 1

Definition at line 143 of file DenseMatrix.cpp.

## ◆ solve [2/2]

int solve | ( | DenseMatrix & | A,
|  | DenseMatrix & | b
| ) |  |
| friend

Solve Ax = b for multiple right-hand-side vectors.

Parameters

  A | Dense matrix to be factored
  b | Dense matrix of RHS's. Each column is a RHS

Definition at line 212 of file DenseMatrix.cpp.

## Member Data Documentation

## ◆ m_ipiv

vector_int m_ipiv
| protected

Vector of pivots. Length is equal to the max of m and n.

Definition at line 125 of file DenseMatrix.h.

Referenced by DenseMatrix::DenseMatrix(), DenseMatrix::ipiv(), and DenseMatrix::resize().

## ◆ m_colPts

std::vector<doublereal*> m_colPts
| protected

Vector of column pointers.

Definition at line 128 of file DenseMatrix.h.

Referenced by DenseMatrix::const_colPts(), DenseMatrix::DenseMatrix(), and DenseMatrix::resize().

## ◆ m_useReturnErrorCode

int m_useReturnErrorCode

Error Handling Flag.

The default is to set this to 0. In this case, if a factorization is requested and can't be achieved, a CESingularMatrix exception is triggered. No return code is used, because an exception is thrown. If this is set to 1, then an exception is not thrown. Routines return with an error code, that is up to the calling routine to handle correctly. Negative return codes always throw an exception.

Definition at line 140 of file DenseMatrix.h.

## ◆ m_printLevel

int m_printLevel

Print Level.

Printing is done to the log file using the routine writelogf().

Level of printing that is carried out. Only error conditions are printed out, if this value is nonzero.

Definition at line 149 of file DenseMatrix.h.

The documentation for this class was generated from the following files:

- DenseMatrix.h
- DenseMatrix.cpp